image: node:8.10

stages:
  - test
  - deploy
  - integration

before_script:
    - npm install -g serverless
    - bash install.sh


test before deploy:
  stage: test
  script:
    - npm run test-unit

deploy to develop:
  stage: deploy
  only:
    - develop
  script:
    - serverless config credentials --provider aws --key $AWS_ACCESS_KEY_ID --secret $AWS_SECRECT_ACCESS_KEY
    - bash deploy.sh dev us-east-1
  environment: dev

integration test after deploy:
  stage: integration
  script:
    - npm run test-integration
  environment: dev
  only:
    - develop

deploy to prod:
    stage: deploy
    only:
      - master
    script:
      - serverless config credentials --provider aws --key $AWS_ACCESS_KEY_ID --secret $AWS_SECRECT_ACCESS_KEY
      - bash deploy.sh prod us-east-1
    environment: prod
    when: manual
